#include "headers.h"
#ifndef ESP_H
#define ESP_H

#include <string>
/*------------------------------------------------------------*/
#define WEAPONSIZE 0x44 
#define MAX_PLAYERS 64
#define MAX_ENTITIES 1024
#define ENTITY_SIZE 0x1DC
#define ENTITY_BASE 0x84F2D8   
#define CLIENTINFO_SIZE 0x4CC
#define CLIENTINFO_BASE 0x839270
#define FONTS_SMALLDEV "fonts/smallDevFont"
enum ETeams
{
	TEAM_FREE,
	TEAM_OPSP,
	TEAM_MASA,
	TEAM_SPEC
};
CEntity * gLocalEntity = NULL;
CClientInfo * gLocalInfo = NULL;
					/*R*//*G*//*B*//*A*/
FColor Red = FColor( 1.f, 0.f, 0.f, 1.f );
FColor Yel = FColor( 1.f, 1.f, 0.f, 1.f );

static void (*hSendCommand)(int x,int x2,char *cvar) = (void (__cdecl *)(int,int,char *))0x004F9AB0;

typedef WORD (*RegisterTag)( char *, int, size_t  );
RegisterTag RegisterTag_ = (RegisterTag)0x518290;

class CEsp
{
public:

	CEsp( void )
	{

	}

	~CEsp( void )
	{
	}

CEntity * GetEntityIndex( int iIndex )
{
	return ( CEntity* )( ENTITY_BASE + ENTITY_SIZE * iIndex );
}

CClientInfo * GetClientIndex( int iIndex )
{
	return ( CClientInfo* )( CLIENTINFO_BASE + CLIENTINFO_SIZE * iIndex );
}	
INT IsValidEntity( CEntity * pEntity, CClientInfo * pClient )
{
	__int32 bIsAlive;
	return ( pEntity != NULL && pClient != NULL && ( pEntity->bIsValidEnt && pClient->bValidEnt ) );
}
bool IsAlive( CEntity * pEnt )
{
    if( !pEnt )
        return false;

    return (pEnt->bIsAlive & 1);
}
int GetLocalIndex ( void )
{
	_asm mov	eax, 0x9599E0
	_asm mov	eax, [eax]
}
static BOOL CODGetTagPos(WORD wTag, CEntity* pEnt, Vector3* Origin )
{
	if(!pEnt||!pEnt->bIsValidEnt||!pEnt->bIsAlive) return 0;
	DWORD ClientID = pEnt->iClientID;
	DWORD retval;
	_asm
	{
		mov     eax, ClientID
		movzx   eax, word ptr 0x14A9F30[eax*2]
		test	ax,ax
		jz		NotValid

		movsx   edi, ax
		imul    edi, 64h
		add     edi, 0x1477F30
		jz		NotValid

		push	Origin
		push	pEnt
		movzx	ecx, wTag
		mov		edx,0x00434200
		call	edx
		add		esp,0x8
		test	eax,eax
		jnz     Finish
NotValid:
		xor		eax,eax
Finish:
		mov		retval,eax
	}
	return retval;
}
bool GetBoneOrigin ( CEntity* Ent, Vector3 * Origin, WORD Bone )
{
	if(!Ent||!Ent->bIsValidEnt||!Ent->bIsAlive) return 0;
	if(!CODGetTagPos ( Bone, Ent, Origin ) )
		Origin	= &Ent->Location; 
		return Ent->Location;
}
void * Engine_GetFont( const char * szFaceName )
{
	void * pFontReturn = NULL;

	_asm
	{
		PUSH 0;
		PUSH szFaceName;
		MOV ECX, 0x5F1EC0;
		CALL ECX;
		MOV pFontReturn, eax;
		ADD ESP, 0x8;
	}
	return pFontReturn;
}
void Engine_DrawString( char * pFont, float fPosX, float fPosY, FColor * pColor, char * pString, ... )
{
	void * pDrawFont = Engine_GetFont( pFont );
	if ( !pFont )
		return;

	va_list valist;
	char pBuffer[256];
	va_start( valist, pString );
	vsprintf( pBuffer, pString, valist );
	va_end( valist );
	
	float fUnknown1 = 1.0f;
	float fUnknown2 = 1.0f;
	float fUnknown3 = 1.0f;
	float fUnknown4 = 1.00f;
	char * pDrawBuffer = pBuffer;

	_asm
	{
		PUSH 0;
		PUSH 0;
		PUSH fUnknown1;
		PUSH fUnknown2;
		PUSH fUnknown3;
		PUSH fUnknown4;
		PUSH fPosY;
		PUSH fPosX;
		PUSH pDrawFont;
		PUSH 256;
		PUSH pDrawBuffer;
		MOV ECX, pColor;
		MOV EAX, 0x5F6B00; 
		CALL EAX;
		ADD ESP, 0x2C;
	}
}
void DrawString(char* pFont, float x, float y,FColor* pColor, char* pText, ... )
{
	char buf[300] = {'\0'};
	va_list va_alist;
	va_start(va_alist, pText);
	vsprintf(buf, pText, va_alist);
	va_end(va_alist);
	Engine_DrawString(pFont, x, y, pColor, buf);
}
bool BasicIsVisible( CEntity* pEntity )
{
    DWORD dwIsVisible = 0x42DE90;
    _asm
    {
        xor eax, eax;
        mov esi, pEntity;
        push esi;
        mov edi, dword ptr [ dwIsVisible ];
        test edi, edi;
        call edi;
        add esp,4;
        test al,al;
    }
}
D3DXVECTOR3* W2S( D3DXVECTOR3 * dWorldLocation, D3DXVECTOR3 * dOutput )
{
	int scrxc, scryc;
	float xzi, yzi, fov;
	D3DXVECTOR3 v3Diff, dot, ViewOrigin, vRight, vUp, vForward;

	scrxc = camera->iResolutionX / 2;
	scryc = camera->iResolutionY / 2;

	vRight = camera->ViewMatrix[1];
	vUp = camera->ViewMatrix[2];
	vForward = camera->ViewMatrix[0];

	ViewOrigin[0] = camera->Location[0];
	ViewOrigin[1] = camera->Location[1];
	ViewOrigin[2] = camera->Location[2];

	D3DXVec3Normalize(( D3DXVECTOR3* ) &v3Diff, D3DXVec3Subtract(( D3DXVECTOR3* ) &v3Diff, ( D3DXVECTOR3* ) &ViewOrigin, ( D3DXVECTOR3* ) dWorldLocation ));

	dot[0] = D3DXVec3Dot(( D3DXVECTOR3* ) &v3Diff, ( D3DXVECTOR3* ) &vRight );
	dot[1] = D3DXVec3Dot(( D3DXVECTOR3* ) &v3Diff, ( D3DXVECTOR3* ) &vUp );
	dot[2] = D3DXVec3Dot(( D3DXVECTOR3* ) &v3Diff, ( D3DXVECTOR3* ) &vForward );//Download from http://codhacks.ru
	
	if( dot[2] > 0.001 )
		return FALSE;

	dOutput->x = scrxc * ( 1 - ( dot[0] / camera->FovX / dot[2] ));
	dOutput->y = scryc * ( 1 - ( dot[1] / camera->FovY / dot[2] ));
	dOutput->z = dot[2];
}
void DrawPlayers( void )
{
	for ( int i = 0; i < 64; i++ )
	{	
			D3DXVECTOR3 v3DrawPos, v3DrawScr,v3DrawPos2;
			CEntity * pEntity = GetEntityIndex( i );
			CClientInfo * pClientInfo = GetClientIndex( i );
			WORD HeadBone = RegisterTag_( "j_head", 1,7 ); 
			
			if(!GetBoneOrigin(pEntity,&pEntity->Location,HeadBone))
				continue;

			v3DrawPos = pEntity->Location;
			bool isvis = BasicIsVisible( pEntity );
			bool enemy = ( gLocalInfo->iTeamID == TEAM_FREE || pClientInfo->iTeamID != gLocalInfo->iTeamID );

			if ( W2S( &v3DrawPos, &v3DrawScr ) )
			{
				char name[24];
				sprintf(name, "%s", pClientInfo->szPlayerName);
				if ( enemy )
				{
					DrawString( FONTS_SMALLDEV, v3DrawScr.x - ( strlen ( name ) / 2 * 6 ), v3DrawScr.y - 15, isvis ? &Red : &Yel, name, pClientInfo->szPlayerName);//^5[ ^7%s ^5]
				}
				else
				{

				}
			}
		}
	}
};
#endif